/*
 * ToolBar.h
 *
 *  Created on: 2010.09.07.
 *      Author: Karma
 */

#ifndef TOOLBAR_H_
#define TOOLBAR_H_

#include <FBase.h>
#include <FUi.h>

class ToolBar : public Osp::Ui::Controls::Panel,
				public Osp::Ui::IActionEventListener
{
public:
	ToolBar();
	result Construct(const Osp::Graphics::Rectangle &bounds);
	virtual ~ToolBar();

public:
	void AddActionEventListener(Osp::Ui::IActionEventListener &listener);
	void RemoveActionEventListener(Osp::Ui::IActionEventListener &listener);
	result AddButton(Osp::Ui::Controls::Button &button);

private:
	// new methods
	static Osp::Graphics::Bitmap *GetBackgroundBitmap();
	void LayoutButtons();

private:
	// from Panel
	result OnDraw();

private:
	// from IActionEventListener
	void OnActionPerformed (const Osp::Ui::Control &source, int actionId);

private:
	static Osp::Graphics::Bitmap *__bg;
	Osp::Base::Collection::ArrayListT<Osp::Ui::IActionEventListener *> __listeners;
	Osp::Base::Collection::ArrayList __buttons;
};

#endif /* TOOLBAR_H_ */
